searchNodes=[{"doc":"Tree data structure for BEAM in BEAM-way. Each node is a process that contains data and children_pids. The pid is used as pointers.Tree implementation becomes straight forwards with pointers that can point to a node and a shared state that helps in while performing operations on different nodes, say traversals. A work around this would be using Agents.Agents are a simple abstraction around state. Often in Elixir there is a need to share or store state that must be accessed from different processes or by the same process at different points in time. The Agent module provides a basic server implementation that allows state to be retrieved and updated via a simple API.Thus a node in tree can be described as{:ok, node_pid} = Agent.start(fn -&gt; %{data: &quot;some_data&quot;} end)This provides us with a pid which can be used to point to the node and a state that can be manipulated.","ref":"GenTree.html","title":"GenTree","type":"module"},{"doc":"Traverses a tree using BFS.Examplesiex&gt; root = GenTree.from_list([1,2,3,4,5,6]) iex&gt; GenTree.Traversal.bfs(root) [1, 2, 3, 4, 5, 6]","ref":"GenTree.html#bfs/1","title":"GenTree.bfs/1","type":"function"},{"doc":"Counts the number of children of the nodeExamplesiex&gt; root = GenTree.new(5) iex&gt; GenTree.count_children(root) 0 iex&gt; GenTree.insert_child(root, &quot;b&quot;, :left) iex&gt; GenTree.insert_child(root, &quot;a&quot;, :right) iex&gt; GenTree.count_children(root) 2","ref":"GenTree.html#count_children/1","title":"GenTree.count_children/1","type":"function"},{"doc":"Traverses a binary tree using DFS.Traversal types:inorder:preorder:postorderExamplesiex&gt; root = GenTree.from_list([1,2,3,4,5,6]) iex&gt; GenTree.Traversal.dfs(root, :inorder) [4, 2, 5, 1, 6, 3] iex&gt; GenTree.Traversal.dfs(root, :preorder) [1, 2, 4, 5, 3, 6] iex&gt; GenTree.Traversal.dfs(root, :postorder) [4, 5, 2, 6, 3, 1]","ref":"GenTree.html#dfs/2","title":"GenTree.dfs/2","type":"function"},{"doc":"Builds a tree from a datalist in level-order. Data can have nil to skip sub-tree.","ref":"GenTree.html#from_list/2","title":"GenTree.from_list/2","type":"function"},{"doc":"Get the children list of the node","ref":"GenTree.html#get_children/1","title":"GenTree.get_children/1","type":"function"},{"doc":"Get the node data value.Examplesiex&gt; root = GenTree.new(5) iex&gt; root |&gt; GenTree.get_data() 5","ref":"GenTree.html#get_data/1","title":"GenTree.get_data/1","type":"function"},{"doc":"Get the left child of node in case of binary tree [:nary, 2]Examplesiex&gt; root = GenTree.new(5) iex&gt; GenTree.get_left(root)","ref":"GenTree.html#get_left/1","title":"GenTree.get_left/1","type":"function"},{"doc":"Get the node details.Examplesiex&gt; root = GenTree.new(5) iex&gt; root |&gt; GenTree.get_node() %GenTree.Node{children: [], data: 5, left: nil, right: nil}","ref":"GenTree.html#get_node/1","title":"GenTree.get_node/1","type":"function"},{"doc":"Get the right child of node in case of binary tree [:nary, 2]Examplesiex&gt; root = GenTree.new(5) iex&gt; GenTree.get_right(root)","ref":"GenTree.html#get_right/1","title":"GenTree.get_right/1","type":"function"},{"doc":"Return if data has a left child in case of binary tree [:nary, 2] ## Examplesiex&gt; root = GenTree.new(5) iex&gt; GenTree.has_left?(root) false","ref":"GenTree.html#has_left?/1","title":"GenTree.has_left?/1","type":"function"},{"doc":"Return if data has a right child in case of binary tree [:nary, 2] ## Examplesiex&gt; root = GenTree.new(5) iex&gt; GenTree.has_right?(root) false","ref":"GenTree.html#has_right?/1","title":"GenTree.has_right?/1","type":"function"},{"doc":"Inserts child to the node and returns the child pid. child_type can be :left, :right or omitted.Examplesiex(21)&gt; root = GenTree.new(&quot;a&quot;) iex(23)&gt; left_child = GenTree.insert_child(root, &quot;b&quot;, :left) iex(25)&gt; GenTree.get_node(left_child) %GenTree.Node{children: [], data: &quot;b&quot;, left: nil, right: nil}","ref":"GenTree.html#insert_child/3","title":"GenTree.insert_child/3","type":"function"},{"doc":"New node of GenTreeExamplesiex&gt; root = GenTree.new(5) iex&gt; is_pid(root) === true","ref":"GenTree.html#new/1","title":"GenTree.new/1","type":"function"},{"doc":"Updates the data value of the node","ref":"GenTree.html#update_data/2","title":"GenTree.update_data/2","type":"function"},{"doc":"Updates complete node value","ref":"GenTree.html#update_node/2","title":"GenTree.update_node/2","type":"function"}]